Index: doc/papers/general/AMA/AMA-stix/Stix-fonts/stix-t1.enc
===================================================================
--- doc/papers/general/AMA/AMA-stix/Stix-fonts/stix-t1.enc	(revision 49eb6a2332de13d116c1e1d70994bf6e76fd66c7)
+++ doc/papers/general/AMA/AMA-stix/Stix-fonts/stix-t1.enc	(revision 49eb6a2332de13d116c1e1d70994bf6e76fd66c7)
@@ -0,0 +1,260 @@
+%!PS-Adobe-3.0 Resource-Encoding
+%
+/stixt1 [
+/grave           % 0x00 U+0060
+/acute           % 0x01 U+00B4
+/circumflex      % 0x02 U+02C6
+/tilde           % 0x03 U+02DC
+/dieresis        % 0x04 U+00A8
+/hungarumlaut    % 0x05 U+02DD
+/ring            % 0x06 U+02DA
+/caron           % 0x07 U+02C7
+/breve           % 0x08 U+02D8
+/macron          % 0x09 U+00AF
+/dotaccent       % 0x0A U+02D9
+/cedilla         % 0x0B U+00B8
+/ogonek          % 0x0C U+02DB
+/quotesinglbase  % 0x0D U+201A
+/guilsinglleft   % 0x0E U+2039
+/guilsinglright  % 0x0F U+203A
+/quotedblleft    % 0x10 U+201C
+/quotedblright   % 0x11 U+201D
+/quotedblbase    % 0x12 U+201E
+/guillemotleft   % 0x13 U+00AB
+/guillemotright  % 0x14 U+00BB
+/endash          % 0x15 U+2013
+/emdash          % 0x16 U+2014
+/uni200B         % 0x17 U+200B was /cwm
+/perthousandzero % 0x18 ______
+/dotlessi        % 0x19 U+0131
+/uni0237         % 0x1A U+0237 was /dotlessj
+/ff              % 0x1B U+FB00
+/fi              % 0x1C U+FB01
+/fl              % 0x1D U+FB02
+/ffi             % 0x1E U+FB03
+/ffl             % 0x1F U+FB04
+/uni2423         % 0x20 U+2423 was /visiblespace
+/exclam          % 0x21
+/quotedbl        % 0x22
+/numbersign      % 0x23
+/dollar          % 0x24
+/percent         % 0x25
+/ampersand       % 0x26
+/quoteright      % 0x27 U+2019
+/parenleft       % 0x28
+/parenright      % 0x29
+/asterisk        % 0x2A
+/plus            % 0x2B
+/comma           % 0x2C
+/hyphen          % 0x2D
+/period          % 0x2E
+/slash           % 0x2F
+/zero            % 0x30
+/one             % 0x31
+/two             % 0x32
+/three           % 0x33
+/four            % 0x34
+/five            % 0x35
+/six             % 0x36
+/seven           % 0x37
+/eight           % 0x38
+/nine            % 0x39
+/colon           % 0x3A
+/semicolon       % 0x3B
+/less            % 0x3C
+/equal           % 0x3D
+/greater         % 0x3E
+/question        % 0x3F
+/at              % 0x40
+/A               % 0x41
+/B               % 0x42
+/C               % 0x43
+/D               % 0x44
+/E               % 0x45
+/F               % 0x46
+/G               % 0x47
+/H               % 0x48
+/I               % 0x49
+/J               % 0x4A
+/K               % 0x4B
+/L               % 0x4C
+/M               % 0x4D
+/N               % 0x4E
+/O               % 0x4F
+/P               % 0x50
+/Q               % 0x51
+/R               % 0x52
+/S               % 0x53
+/T               % 0x54
+/U               % 0x55
+/V               % 0x56
+/W               % 0x57
+/X               % 0x58
+/Y               % 0x59
+/Z               % 0x5A
+/bracketleft     % 0x5B
+/backslash       % 0x5C
+/bracketright    % 0x5D
+/asciicircum     % 0x5E
+/underscore      % 0x5F
+/quoteleft       % 0x60 U+2018
+/a               % 0x61
+/b               % 0x62
+/c               % 0x63
+/d               % 0x64
+/e               % 0x65
+/f               % 0x66
+/g               % 0x67
+/h               % 0x68
+/i               % 0x69
+/j               % 0x6A
+/k               % 0x6B
+/l               % 0x6C
+/m               % 0x6D
+/n               % 0x6E
+/o               % 0x6F
+/p               % 0x70
+/q               % 0x71
+/r               % 0x72
+/s               % 0x73
+/t               % 0x74
+/u               % 0x75
+/v               % 0x76
+/w               % 0x77
+/x               % 0x78
+/y               % 0x79
+/z               % 0x7A
+/braceleft       % 0x7B
+/bar             % 0x7C
+/braceright      % 0x7D
+/asciitilde      % 0x7E
+/uni2010         % 0x7F U+002D (explicit "hyphen char")
+/uni0102         % 0x80 U+0102
+/uni0104         % 0x81 U+0104
+/uni0106         % 0x82 U+0106
+/uni010C         % 0x83 U+010C
+/uni010E         % 0x84 U+010E
+/uni011A         % 0x85 U+011A
+/uni0118         % 0x86 U+0118
+/uni011E         % 0x87 U+011E
+/uni0139         % 0x88 U+0139
+/uni013D         % 0x89 U+013D
+/Lslash          % 0x8A U+0141
+/uni0143         % 0x8B U+0143
+/uni0147         % 0x8C U+0147
+/uni014A         % 0x8D U+014A
+/uni0150         % 0x8E U+0150
+/uni0154         % 0x8F U+0154
+/uni0158         % 0x90 U+0158
+/uni015A         % 0x91 U+015A
+/Scaron          % 0x92 U+0160
+/uni015E         % 0x93 U+015E
+/uni0164         % 0x94 U+0164
+/uni0162         % 0x95 U+0162
+/uni0170         % 0x96 U+0170
+/uni016E         % 0x97 U+016E
+/Ydieresis       % 0x98 U+0178
+/uni0179         % 0x99 U+0179
+/Zcaron          % 0x9A U+017D
+/uni017B         % 0x9B U+017B
+/uni0132         % 0x9C U+0132
+/uni0130         % 0x9D U+0130
+/uni0111         % 0x9E U+0111
+/section         % 0x9F U+00A7
+/uni0103         % 0xA0 U+0103
+/uni0105         % 0xA1 U+0105
+/uni0107         % 0xA2 U+0107
+/uni010D         % 0xA3 U+010D
+/uni010F         % 0xA4 U+010F
+/uni011B         % 0xA5 U+011B
+/uni0119         % 0xA6 U+0119
+/uni011F         % 0xA7 U+011F
+/uni013A         % 0xA8 U+013A
+/uni013E         % 0xA9 U+013E
+/lslash          % 0xAA U+0142
+/uni0144         % 0xAB U+0144
+/uni0148         % 0xAC U+0148
+/uni014B         % 0xAD U+014B
+/uni0151         % 0xAE U+0151
+/uni0155         % 0xAF U+0155
+/uni0159         % 0xB0 U+0159
+/uni015B         % 0xB1 U+015B
+/scaron          % 0xB2 U+0161
+/uni015F         % 0xB3 U+015F
+/uni0165         % 0xB4 U+0165
+/uni0163         % 0xB5 U+0163
+/uni0171         % 0xB6 U+0171
+/uni016F         % 0xB7 U+016F
+/ydieresis       % 0xB8 U+00FF
+/uni017A         % 0xB9 U+017A
+/zcaron          % 0xBA U+017E
+/uni017C         % 0xBB U+017C
+/uni0133         % 0xBC U+0133
+/exclamdown      % 0xBD U+00A1
+/questiondown    % 0xBE U+00BF
+/sterling        % 0xBF U+00A3
+/Agrave          % 0xC0
+/Aacute          % 0xC1
+/Acircumflex     % 0xC2
+/Atilde          % 0xC3
+/Adieresis       % 0xC4
+/Aring           % 0xC5
+/AE              % 0xC6
+/Ccedilla        % 0xC7
+/Egrave          % 0xC8
+/Eacute          % 0xC9
+/Ecircumflex     % 0xCA
+/Edieresis       % 0xCB
+/Igrave          % 0xCC
+/Iacute          % 0xCD
+/Icircumflex     % 0xCE
+/Idieresis       % 0xCF
+/Eth             % 0xD0
+/Ntilde          % 0xD1
+/Ograve          % 0xD2
+/Oacute          % 0xD3
+/Ocircumflex     % 0xD4
+/Otilde          % 0xD5
+/Odieresis       % 0xD6
+/OE              % 0xD7 U+0152
+/Oslash          % 0xD8
+/Ugrave          % 0xD9
+/Uacute          % 0xDA
+/Ucircumflex     % 0xDB
+/Udieresis       % 0xDC
+/Yacute          % 0xDD
+/Thorn           % 0xDE
+/uni1E9E         % 0xDF (U+1E9E, /S_S) was /Germandbls
+/agrave          % 0xE0
+/aacute          % 0xE1
+/acircumflex     % 0xE2
+/atilde          % 0xE3
+/adieresis       % 0xE4
+/aring           % 0xE5
+/ae              % 0xE6
+/ccedilla        % 0xE7
+/egrave          % 0xE8
+/eacute          % 0xE9
+/ecircumflex     % 0xEA
+/edieresis       % 0xEB
+/igrave          % 0xEC
+/iacute          % 0xED
+/icircumflex     % 0xEE
+/idieresis       % 0xEF
+/eth             % 0xF0
+/ntilde          % 0xF1
+/ograve          % 0xF2
+/oacute          % 0xF3
+/ocircumflex     % 0xF4
+/otilde          % 0xF5
+/odieresis       % 0xF6
+/oe              % 0xF7 U+0153
+/oslash          % 0xF8
+/ugrave          % 0xF9
+/uacute          % 0xFA
+/ucircumflex     % 0xFB
+/udieresis       % 0xFC
+/yacute          % 0xFD
+/thorn           % 0xFE
+/germandbls      % 0xFF U+00DF
+] def