Index: src/Parser/parser.yy
===================================================================
--- src/Parser/parser.yy	(revision 637dd9c6c6f1e227e65a024443938074659ae04c)
+++ src/Parser/parser.yy	(revision 52df81cb97f900f9cb8ccdeb0414766acb698a37)
@@ -10,6 +10,6 @@
 // Created On       : Sat Sep  1 20:22:55 2001
 // Last Modified By : Peter A. Buhr
-// Last Modified On : Thu May  3 08:20:09 2018
-// Update Count     : 3225
+// Last Modified On : Wed May  9 17:17:35 2018
+// Update Count     : 3244
 //
 
@@ -302,5 +302,5 @@
 
 %type<decl> field_declaration field_declaration_list field_declarator field_declaring_list
-%type<en> field field_list field_name fraction_constants
+%type<en> field field_list field_name fraction_constants_opt
 
 %type<decl> external_function_definition function_definition function_array function_declarator function_no_ptr function_ptr
@@ -499,6 +499,8 @@
 	| type_name '.' no_attr_identifier					// CFA, nested type
 		{ SemanticError( yylloc, "Qualified names are currently unimplemented." ); $$ = nullptr; }
+//		{ $$ = nullptr; }
 	| type_name '.' '[' push field_list pop ']'			// CFA, nested type / tuple field selector
 		{ SemanticError( yylloc, "Qualified names are currently unimplemented." ); $$ = nullptr; }
+//		{ $$ = nullptr; }
 	| GENERIC '(' assignment_expression ',' generic_assoc_list ')' // C11
 		{ SemanticError( yylloc, "_Generic is currently unimplemented." ); $$ = nullptr; }
@@ -533,16 +535,18 @@
 	| postfix_expression '.' no_attr_identifier
 		{ $$ = new ExpressionNode( build_fieldSel( $1, build_varref( $3 ) ) ); }
+	| postfix_expression '.' INTEGERconstant			// CFA, tuple index
+		{ $$ = new ExpressionNode( build_fieldSel( $1, build_constantInteger( *$3 ) ) ); }
+	| postfix_expression FLOATING_FRACTIONconstant		// CFA, tuple index
+		{ $$ = new ExpressionNode( build_fieldSel( $1, build_field_name_FLOATING_FRACTIONconstant( *$2 ) ) ); }
 	| postfix_expression '.' '[' push field_list pop ']' // CFA, tuple field selector
 		{ $$ = new ExpressionNode( build_fieldSel( $1, build_tuple( $5 ) ) ); }
-	| postfix_expression FLOATING_FRACTIONconstant		// CFA, tuple index
-		{ $$ = new ExpressionNode( build_fieldSel( $1, build_field_name_FLOATING_FRACTIONconstant( *$2 ) ) ); }
 	| postfix_expression ARROW no_attr_identifier
 		{
 			$$ = new ExpressionNode( build_pfieldSel( $1, *$3 == "0" || *$3 == "1" ? build_constantInteger( *$3 ) : build_varref( $3 ) ) );
 		}
-	| postfix_expression ARROW '[' push field_list pop ']' // CFA, tuple field selector
-			{ $$ = new ExpressionNode( build_pfieldSel( $1, build_tuple( $5 ) ) ); }
 	| postfix_expression ARROW INTEGERconstant			// CFA, tuple index
 		{ $$ = new ExpressionNode( build_pfieldSel( $1, build_constantInteger( *$3 ) ) ); }
+	| postfix_expression ARROW '[' push field_list pop ']' // CFA, tuple field selector
+		{ $$ = new ExpressionNode( build_pfieldSel( $1, build_tuple( $5 ) ) ); }
 	| postfix_expression ICR
 	  	{ $$ = new ExpressionNode( build_unary_ptr( OperKinds::IncrPost, $1 ) ); }
@@ -597,9 +601,9 @@
 
 field_name:
-	INTEGERconstant	fraction_constants
+	INTEGERconstant	fraction_constants_opt
 		{ $$ = new ExpressionNode( build_field_name_fraction_constants( build_constantInteger( *$1 ), $2 ) ); }
-	| FLOATINGconstant fraction_constants
+	| FLOATINGconstant fraction_constants_opt
 		{ $$ = new ExpressionNode( build_field_name_fraction_constants( build_field_name_FLOATINGconstant( *$1 ), $2 ) ); }
-	| no_attr_identifier fraction_constants
+	| no_attr_identifier fraction_constants_opt
 		{
 			$$ = new ExpressionNode( build_field_name_fraction_constants( build_varref( $1 ), $2 ) );
@@ -607,8 +611,8 @@
 	;
 
-fraction_constants:
+fraction_constants_opt:
 	// empty
 		{ $$ = nullptr; }
-	| fraction_constants FLOATING_FRACTIONconstant
+	| fraction_constants_opt FLOATING_FRACTIONconstant
 		{
 			Expression * constant = build_field_name_FLOATING_FRACTIONconstant( *$2 );
@@ -2390,5 +2394,7 @@
 external_definition_list:
 	external_definition
-	| external_definition_list { forall = xxx; } push external_definition
+	| external_definition_list
+		{ forall = xxx; }
+	  push external_definition
 		{ $$ = $1 ? $1->appendList( $4 ) : $4; }
 	;